SLASH_TOKENPRICE1, SLASH_TOKENPRICE2 = '/tp', '/tokenprice'
SLASH_TOKEN = '/token'

local function LoadedAddon(self, event, ...)
    SendLoadMessage()
    C_WowTokenPublic.UpdateMarketPrice()
end
local Ticker
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", LoadedAddon)
function SendLoadMessage()
    f:UnregisterEvent("ADDON_LOADED")
    C_WowTokenPublic.UpdateMarketPrice()
    if CheckTimer == nil then
        CheckTimer = 60
    end
    local TokenIcon
    TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:19:19:0:0|t'
    DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. "TokenPriceNotifier Loaded!" .. TokenIcon, 0.992, 0.850, 0.050)
    Ticker = C_Timer.NewTicker(CheckTimer, PrintPriceOnChat)
end
function SlashCmdList.TOKEN(msg, editBox)
    local command, rest = msg:match("^(%S*)%s*(.-)$")
    if command == "timer" and rest ~= "" then
        CheckTimer = MinutesToSeconds(rest)
        Ticker:Cancel()
        Ticker = C_Timer.NewTicker(MinutesToSeconds(rest), PrintPriceOnChat)
        print("[TokenPriceNotifier] Setting check timer to " .. rest .. " minutes.")
        PrintPriceOnChat()
    else 
        print("[TokenPriceNotifier] Commands:")
        print("/token timer <minutes> (Set checking token price to every x minutes, 1 is default.)")
        print("/tp, /tokenprice (Print current token price on chat)")
    end
end
function SlashCmdList.TOKENPRICE(msg, editbox)
C_WowTokenPublic.UpdateMarketPrice()
if C_WowTokenPublic.GetCurrentMarketPrice() ~= nil then
    local name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable = GetChatWindowInfo(1);
    local GoldIcon = '|TInterface\\MoneyFrame\\UI-GoldIcon:14:14:2:0|t'
    local TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:0:0|t'
    local TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
    local UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-12:11|t'
    local DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-14.5:-13|t'
    if fontSize == 12 then 
        TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
        UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-12:11|t'
        DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-14.5:-13|t'
    elseif fontSize == 14 then
        TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
        UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-13:13|t'
        DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-15.5:-14|t'
    elseif fontSize == 16 then
        TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
        UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-16:14|t'
        DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-19:-15|t'
    elseif fontSize == 18 then
        TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
        UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-18:15|t'
        DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-21:-17|t'
    end
    C_WowTokenPublic.UpdateMarketPrice()
    if LastTokenPrice == nil then
        LastTokenPrice = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
    end
    local TokenPriceValue = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
    local TokenPriceString
    TokenPriceString = string.sub(TokenPriceValue, 1, 3) .. ',' .. string.sub(TokenPriceValue, 4, 9)
    if TokenPriceValue == LastTokenPrice then -- Same Value
        DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. TokenIcon, 0.992, 0.850, 0.050)
    end
    if TokenPriceValue < LastTokenPrice then -- Smaller Value
        DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. DownIcon .. TokenIconRight, 0.992, 0.850, 0.050)
    end
    if TokenPriceValue > LastTokenPrice then -- Higher Value
        DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. UpIcon .. TokenIconRight, 0.992, 0.850, 0.050)
    end
    LastTokenPrice = TokenPriceValue
end
end
function MinutesToSeconds(minutes)
    local seconds = minutes * 60
    return seconds
end
function PrintPriceOnChat()
    C_WowTokenPublic.UpdateMarketPrice()
    if C_WowTokenPublic.GetCurrentMarketPrice() ~= nil then
        local name, fontSize, r, g, b, alpha, shown, locked, docked, uninteractable = GetChatWindowInfo(1);
        local GoldIcon = '|TInterface\\MoneyFrame\\UI-GoldIcon:14:14:2:0|t'
        local TokenIcon = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:0:0|t'
        local TokenIconRight
        local DownIcon
        local UpIcon
        if fontSize == 12 then 
            TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
            UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-12:11|t'
            DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-14.5:-13|t'
        elseif fontSize == 14 then
            TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
            UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-13:13|t'
            DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-15.5:-14|t'
        elseif fontSize == 16 then
            TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
            UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-16:14|t'
            DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-19:-15|t'
        elseif fontSize == 18 then
            TokenIconRight = '|TInterface\\ICONS\\WoW_Token01.PNG:25:25:-13:0|t'
            UpIcon = '|TInterface\\Buttons\\Arrow-Up-Up.PNG:0:0:-18:15|t'
            DownIcon = '|TInterface\\Buttons\\Arrow-Down-Down.PNG:0:0:-21:-17|t'
        end
        if LastTokenPrice == nil then
            LastTokenPrice = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        end
        local TokenPriceValue = C_WowTokenPublic.GetCurrentMarketPrice() / 100 / 100
        local TokenPriceString
        TokenPriceString = string.sub(TokenPriceValue, 1, 3) .. ',' .. string.sub(TokenPriceValue, 4, 9)
        if TokenPriceValue < LastTokenPrice then -- Smaller Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. DownIcon .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        if TokenPriceValue > LastTokenPrice then -- Higher Value
            DEFAULT_CHAT_FRAME:AddMessage(TokenIcon .. " Price: " .. TokenPriceString .. GoldIcon .. UpIcon .. TokenIconRight, 0.992, 0.850, 0.050)
        end
        LastTokenPrice = TokenPriceValue
    end
end